/*
quasiCrystals v3
------------------
2013 by nobody
*/

global quasiCrystals3

struct var_struct
	(
		name="",
		type=1,
		value=""
	)
	struct rule_struct
	(
		name=" ",
		enabled=true,
		iterations=" ",
		parent=" ",
		nth=" ",
		obj_type=1,
		obj_inst,
		size=" ",
		preeval=" ",
		eval=" ",
		color_start=(color 160 190 50),
		color_end=(color 160 190 50)
	)

rollout quasiCrystals3 "quasiCrystals3 - 3D pattern analyzer" width:248 height:370
(
	global spinner_min=-999999999
	global spinner_max=999999999
	local g_seed=1
	
	local maintitle="quasiCrystals3"
	local copyright="(c)2013 by santex"
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals3\\")
	local configfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals3\\")+"quasiCrystals3.ini")
	local devlogfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals3\\")+"quasiCrystals3.log")
	global all_objects=#()
	
	--local obj_types = #("Point","Geosphere","Box","Pyramid","Instanced ...")
	global obj_types = #("Point","GeoSphere","Box","Teapot","Pyramid","Instanced ...")
	--local var_types = #("Integer","Float","Boolean","Random","Expr.","Const.","Special")
	local var_types = #("Integer","Float","Boolean","Random","Expr.","Const.")
	local var_constants = #("Pi(3.14)","Phi(1.618)","e(2.718)","4.669")
	local var_constants_val = #("3.141592654", "1.618033989", "2.71828","4.669201609")
	
	--local dev_print_post = true
	
	/*struct var_struct
	(
		name="",
		type=1,
		value=""
	)
	struct rule_struct
	(
		name=" ",
		enabled=true,
		iterations=" ",
		parent=" ",
		nth=" ",
		obj_type=1,
		obj_inst,
		size=" ",
		preeval=" ",
		eval=" ",
		color_start=(color 160 190 50),
		color_end=(color 160 190 50)
	)*/
	global all_vars=#()
	global all_rules=#()
	global quasiCrystals3_inst_obj
	
	listbox lbx_vars "Global variables:" height:8 width:120
	radiobuttons rbt_var_type "Type:" labels:var_types default:1 columns:1 pos:[160,8]
	button btn_var_up "/\\" pos:[134,23] width:18 height:40 tooltip:"Move selected variable up"
	button btn_var_down "\/" pos:[134,64] width:18 height:40 tooltip:"Move selected variable down"
	button btn_var_del "X" pos:[134,104] width:18 height:30 tooltip:"Delete selected variable"
	
	edittext edt_var_name "Name:" pos:[8,146] width:180
	button btn_var_add ">" tooltip:"Add new variable" pos:[190,146] height:18

	spinner spn_var_int "Integer value:" type:#integer range:[spinner_min,spinner_max,0] visible:true pos:[8,176]
	spinner spn_var_float "Float value:" type:#float range:[spinner_min,spinner_max,0] visible:false pos:[8,176]
	radiobuttons rbt_var_bool "Boolean value:" labels:#("false","true") default:1 columns:2 visible:false pos:[8,176]
	
	spinner spn_var_random_min "Random value (min):" type:#float range:[spinner_min,spinner_max,0] visible:false pos:[8,176]
	spinner spn_var_random_max "(max):" type:#float range:[spinner_min,spinner_max,0] visible:false pos:[75,196]
	
	edittext edt_var_expr "Expression:" visible:false pos:[8,176] height:40
	radiobuttons rbt_var_const "" labels:var_constants default:1 columns:3 visible:false pos:[8,176]
	button btn_var_special "Open special variable options ..." visible:false pos:[8,176] width:206
	
	label lbl0 "---------------------------------------------------" pos:[8,216] enabled:false
	
	listbox lbx_rules "Rules:" height:10 width:180 pos:[8,232]
	checkbutton btn_rule_on "on" width:18 height:20 pos:[190,248] tooltip:"Enable/Disable selected rule"
	button btn_rule_up "/\\" pos:[190,268] width:18 height:40 tooltip:"Move selected rule up"
	button btn_rule_down "\/" pos:[190,308] width:18 height:40 tooltip:"Move selected rule down"
	button btn_rule_del "X" pos:[190,350] width:18 height:30 tooltip:"Delete selected rule"
	button btn_rule_add "Add new rule ..." width:100 pos:[8,390]
	button btn_rule_edit "Edit selected ..." width:100 pos:[108,390] tooltip:"Edit selected rule"
	
	label lbl1 "---------------------------------------------------" enabled:false
	
	button btn_load_config "Load config" width:100 pos:[8,436] tooltip:"Load saved configuration"
	button btn_save_config "Save config" width:100 pos:[108,436] tooltip:"Save current configuration"
	button btn_import_config "Import from config ..." tooltip:"Import rules and variables from saved configuration file"
	spinner spn_seed "Global seed:" type:#integer range:[1,spinner_max,g_seed] visible:false
	checkbox chk_autoupdate "Auto-evaluation (use with caution!)"
	button btn_eval "EVALUATE" width:206
	button btn_reset "RESET everything to default" width:206
	checkbox chk_dev_post "Print eval. code into MAXScript Listener"
	checkbox chk_time_post "Print evaluation time into Listener"
	checkbox chk_hide_workdlg "Hide 'Working dialog' during evaluation"
	
	include "santex_fnlib.ms"
	
	fn enableRulesUI=
	(
		quasiCrystals3.lbx_rules.enabled=\
		quasiCrystals3.btn_rule_on.enabled=\
		quasiCrystals3.btn_rule_up.enabled=\
		quasiCrystals3.btn_rule_down.enabled=\
		quasiCrystals3.btn_rule_del.enabled=\
		quasiCrystals3.btn_rule_add.enabled=\
		quasiCrystals3.btn_rule_edit.enabled=true
		
		quasiCrystals3.btn_load_config.enabled=\
		quasiCrystals3.btn_save_config.enabled=\
		quasiCrystals3.btn_import_config.enabled=\
		quasiCrystals3.btn_reset.enabled=\
		quasiCrystals3.btn_eval.enabled=\
		quasiCrystals3.spn_seed.enabled=\
		quasiCrystals3.chk_autoupdate.enabled=true
	)
	fn disableRulesUI=
	(
		quasiCrystals3.lbx_rules.enabled=\
		quasiCrystals3.btn_rule_on.enabled=\
		quasiCrystals3.btn_rule_up.enabled=\
		quasiCrystals3.btn_rule_down.enabled=\
		quasiCrystals3.btn_rule_del.enabled=\
		quasiCrystals3.btn_rule_add.enabled=\
		quasiCrystals3.btn_rule_edit.enabled=false
		
		quasiCrystals3.btn_load_config.enabled=\
		quasiCrystals3.btn_save_config.enabled=\
		quasiCrystals3.btn_import_config.enabled=\
		quasiCrystals3.btn_reset.enabled=\
		quasiCrystals3.btn_eval.enabled=\
		quasiCrystals3.spn_seed.enabled=\
		quasiCrystals3.chk_autoupdate.enabled=false
	)
	fn setVarType=
	(
		spn_var_int.visible=\
		spn_var_float.visible=\
		rbt_var_bool.visible=\
		spn_var_random_min.visible=\
		spn_var_random_max.visible=\
		btn_var_special.visible=\
		rbt_var_const.visible=\
		edt_var_expr.visible=false
		
		if(rbt_var_type.state==1) do spn_var_int.visible=true
		if(rbt_var_type.state==2) do spn_var_float.visible=true
		if(rbt_var_type.state==3) do rbt_var_bool.visible=true
		if(rbt_var_type.state==4) do spn_var_random_min.visible=true
		if(rbt_var_type.state==4) do spn_var_random_max.visible=true
		if(rbt_var_type.state==5) do edt_var_expr.visible=true
		if(rbt_var_type.state==6) do rbt_var_const.visible=true
		if(rbt_var_type.state==7) do btn_var_special.visible=true
	)
	fn getVarsSave=
	(
		local temp = ""
		for i=1 to all_vars.count do
		(
			local var = (all_vars[i].name + "@" + all_vars[i].type as string + "@" + all_vars[i].value as string)
			temp += (var + ";")
		)
		return temp
	)
	fn getVarsLoad vars=
	(
		local arr1 = filterstring vars ";"
		local temp = #()
		for i=1 to arr1.count do
		(
			try(
			local arr2 = filterstring arr1[i] "@"
			local new_var = var_struct name:(arr2[1] as string) type:(arr2[2] as integer) value:(arr2[3] as string)
			append temp new_var
			)catch()
		)
		return temp
	)
	fn getParsedEval etext=
	(
		local parsed = ""
		for i=1 to etext.count do
		(
			if (etext[i]=="\n") then parsed += ";"
			else parsed += etext[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getReParsedEval str=
	(
		local parsed = ""
		for i=1 to str.count do
		(
			if (str[i]==";") then parsed += "\n"
			else parsed += str[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getRulesSave=
	(
		local temp = ""
		for i=1 to all_rules.count do
		(
			local rule_inst_obj_name = " "
			--if(all_rules[i].obj_inst!=undefined) do rule_inst_obj_name = all_rules[i].obj_inst.name
			
			local rule_preeval = (getParsedEval (all_rules[i].preeval))
			local rule_eval = (getParsedEval (all_rules[i].eval))
			local rule = (all_rules[i].name + "@"\
				+ (all_rules[i].enabled as string) + "@"\
				+ all_rules[i].iterations + "@"\
				+ all_rules[i].parent + "@"\
				+ all_rules[i].nth + "@"\
				+ (all_rules[i].obj_type as string) + "@"\
				+ rule_inst_obj_name + "@"\
				+ all_rules[i].size + "@"\
				+ rule_preeval + "@"\
				+ rule_eval + "@"\
				+ (all_rules[i].color_start as string)  + "@"\
				+ (all_rules[i].color_end as string)  + "@"\
				)
			temp += (rule + "|")
		)
		return temp
	)
	fn getRulesLoad vars=
	(
		local arr1 = filterstring vars "|"
		local temp = #()
		for i=1 to arr1.count do
		(
			local arr2 = filterstring arr1[i] "@"
			local new_rule = rule_struct()
			new_rule.name = arr2[1] as string
			new_rule.enabled = arr2[2] as booleanClass
			new_rule.iterations = arr2[3] as string
			
			new_rule.parent = arr2[4] as string
			new_rule.nth = arr2[5] as string
			new_rule.obj_type = arr2[6] as integer
			--new_rule.obj_inst = arr2[7] as string
			
			try(i_o = execute("$"+arr2[7] as string +"*"))catch()
				print i_o
			--if (i_o!=undefined) do new_rule.obj_inst = execute("$"+arr2[7] as string +"*")
			
			
			new_rule.size = arr2[8] as string
			
			new_rule_preeval = getReParsedEval (arr2[9] as string)
			new_rule_eval = getReParsedEval (arr2[10] as string)
			
			new_rule.preeval = new_rule_preeval as string
			new_rule.eval = new_rule_eval as string
			
			new_rule.color_start = execute(arr2[11] as string)
			new_rule.color_end = execute(arr2[12] as string)
			
			append temp new_rule
		)
		return temp
	)
	
	fn closeAllDialogs=
	(
		try(destroydialog quasiCrystals3_addrule)catch()
		try(destroydialog quasiCrystals3_editrule)catch()
		try(destroydialog quasiCrystals3_special)catch()
	)
	fn deleteAllObjects=
	(
		try(delete all_objects)catch(
			
		)
		--delete all_objects
		all_objects=#()
	)
	fn isUniqueVar var=
	(
		for i=1 to all_vars.count do
		(
			if (var==all_vars[i].name) do return false
		)
		return true
	)
	fn getNewVarValue=
	(
		if(rbt_var_type.state==1) do return spn_var_int.value
		if(rbt_var_type.state==2) do return spn_var_float.value
		if(rbt_var_type.state==3) do
		(
			if(rbt_var_bool.state==1) do return "false"
			if(rbt_var_bool.state==2) do return "true"
		)
		if(rbt_var_type.state==4) do
		(
			return ("random "+spn_var_random_min.value as string+" "+spn_var_random_max.value as string)
		)
		
		if(rbt_var_type.state==5) do return edt_var_expr.text
		if(rbt_var_type.state==6) do
		(
			--if(rbt_var_const.state==1) do return "3.141592654"
			--if(rbt_var_const.state==2) do return "1.618033989"
			return (var_constants_val[rbt_var_const.state])
		)
		if(rbt_var_type.state==7) do
		(
			--return "special"
		)
	)
	fn evalCode=
	(
		if (chk_hide_workdlg.checked) then
		()else(
			slib.workDlg.open()
			slib.workDlg.job "Working ..."
		)
		
		deleteAllObjects()
		filein "quasiCrystals3_eval.ms"
		
		try(slib.workDlg.close())catch()
	)
	fn refreshVarsList=
	(
		local temp=#()
		lbx_vars.items=#()
		for i=1 to all_vars.count do
		(
			append temp (all_vars[i].name+" = "+all_vars[i].value as string )
		)
		lbx_vars.items=temp
		
	)
	fn refreshRulesList=
	(
		local temp=#()
		lbx_rules.items=#()
		for i=1 to all_rules.count do
		(
			if (NOT all_rules[i].enabled) then _e=(i as string + "<disabled>: ") else _e=(i as string + ": ")
			append temp ( _e + all_rules[i].name + " [ "+all_rules[i].iterations + " ]")
		)
		lbx_rules.items=temp
		try(btn_rule_on.checked = all_rules[lbx_rules.selection].enabled)catch()
		
		if(chk_autoupdate.checked) do evalCode()
	)
	fn setRule state=
	(
		try(all_rules[lbx_rules.selection].enabled = state
		refreshRulesList()
		)catch()
	)
	
	fn updateVar=
	(
		if (edt_var_name.text!=""\
			AND edt_var_name.text.count!=0\
			AND edt_var_name.text!="_this"\
			AND (isUniqueVar edt_var_name.text)) then
		(
			
		)else
		(
			for i=1 to all_vars.count do
			(
				if (edt_var_name.text==all_vars[i].name) do
				(
					all_vars[i].type = rbt_var_type.state
					all_vars[i].value = ((getNewVarValue()) as string)
				)
			)
		)
		
		refreshVarsList()
		--lbx_vars.selection = lbx_vars.items.count
		if(chk_autoupdate.checked) do evalCode()
	)
	fn refreshVarUI=
	(
		if(lbx_vars.selection!=0) do
		(
			local var = filterString (lbx_vars.items[lbx_vars.selection]) " = "
			for i=1 to all_vars.count do
			(
				if(var[1]==all_vars[i].name) do
				(
					edt_var_name.text = all_vars[i].name
					rbt_var_type.state = all_vars[i].type as integer
					
					if(all_vars[i].type==1) do spn_var_int.value=(all_vars[i].value as integer)
					if(all_vars[i].type==2) do spn_var_float.value=(all_vars[i].value as float)
					if(all_vars[i].type==3) do
					(
						if(all_vars[i].value=="false") do rbt_var_bool.state=1
						if(all_vars[i].value=="true") do rbt_var_bool.state=2
					)
					if(all_vars[i].type==4) do
					(
						local val = filterstring all_vars[i].value " "
						spn_var_random_min.value=val[2] as float
						spn_var_random_max.value=val[3] as float
					)
					if(all_vars[i].type==5) do edt_var_expr.text=all_vars[i].value as string
					if(all_vars[i].type==6) do
					(
						--if(all_vars[i].value=="3.141592654") do rbt_var_const.state=1
						--if(all_vars[i].value=="1.618033989") do rbt_var_const.state=2
					)
					if(all_vars[i].type==7) do
					(
						
					)
				)
			)
			setVarType()
		)
	)
	fn saveAllSettings=
	(
		/*slib.setting.save "iterations" spn_iterations.value
		slib.setting.save "obj_type" ddl_obj_type.selection
		slib.setting.save "random_color" chk_random_color.checked
		slib.setting.save "autoupdate" chk_autoupdate.checked
		slib.setting.save "eval" (getParsedEval())
		slib.setting.save "obj_size" spn_obj_size.value
		slib.setting.save "obj_quality" spn_obj_quality.value
			
		slib.setting.save "vars" (getVarsSave())*/
		
		slib.setting.save "seed" spn_seed.value
		slib.setting.save "autoupdate" chk_autoupdate.checked
		slib.setting.save "print_code" chk_dev_post.checked
		slib.setting.save "print_time" chk_time_post.checked
		slib.setting.save "hide_workdlg" chk_hide_workdlg.checked
		
		slib.setting.save "vars" (getVarsSave())
		slib.setting.save "rules" (getRulesSave())
	)
	fn loadAllSettings=
	(
		/*spn_iterations.value=slib.setting.load "iterations" 377
		ddl_obj_type.selection=slib.setting.load "obj_type" 1
		chk_random_color.checked=slib.setting.load "random_color" false
		chk_autoupdate.checked=slib.setting.load "autoupdate" false
		edt_eval.text=getReParsedEval (slib.setting.loadStr "eval" "")
		spn_obj_size.value=slib.setting.load "obj_size" 20
		spn_obj_quality.value=slib.setting.load "obj_quality" 3
		
		lbx_vars.items = slib.sarray.getarray (slib.setting.loadStr "vars" "") ";" 0*/
		
		spn_seed.value=slib.setting.load "seed" 1
		chk_autoupdate.checked=slib.setting.load "autoupdate" false
		chk_time_post.checked=slib.setting.load "print_time" false
		chk_dev_post.checked=slib.setting.load "print_code" false
		chk_hide_workdlg.checked=slib.setting.load "hide_workdlg" false
		
		all_vars = getVarsLoad (slib.setting.loadStr "vars" "")
		
		refreshVarsList()
		lbx_vars.selection = lbx_vars.items.count
		refreshVarUI()
		
		all_rules = getRulesLoad (slib.setting.loadStr "rules" "")
		refreshRulesList()
		lbx_rules.selection = lbx_rules.items.count
	)
	fn moveVar dir=
	(
		if (dir=="up") do dir=-1
		if (dir=="down") do dir=1
		if (lbx_vars.selection!=0 AND \
			(dir==-1 AND lbx_vars.selection!=1) OR \
			(dir==1 AND lbx_vars.selection!=lbx_vars.items.count)
		) do
		(
			local var=all_vars[lbx_vars.selection]
			deleteItem all_vars lbx_vars.selection
			insertItem var all_vars (lbx_vars.selection+dir)
			
			refreshVarsList()
			lbx_vars.selection = (lbx_vars.selection+dir)
			--refreshVarUI()
		)
	)
	fn moveRule dir=
	(
		if (dir=="up") do dir=-1
		if (dir=="down") do dir=1
		if (lbx_rules.selection!=0 AND \
			(dir==-1 AND lbx_rules.selection!=1) OR \
			(dir==1 AND lbx_rules.selection!=lbx_rules.items.count)
		) do
		(
			local var=all_rules[lbx_rules.selection]
			deleteItem all_rules lbx_rules.selection
			insertItem var all_rules (lbx_rules.selection+dir)
			
			refreshRulesList()
			lbx_rules.selection = (lbx_rules.selection+dir)
			--refreshRUleUI() ???
		)
	)
	
	on rbt_var_type changed state do
	(
		setVarType()
		updateVar()
	)
	
	on btn_var_special pressed do filein "quasiCrystals3_special.ms"
		
	on btn_var_add pressed do
	(
		if (edt_var_name.text!=""\
			AND edt_var_name.text.count!=0\
			AND edt_var_name.text!="_this"\
			AND (isUniqueVar edt_var_name.text)) then
		(
			local new_var = var_struct name:edt_var_name.text type:rbt_var_type.state value:(getNewVarValue())
			append all_vars new_var
		)else
		(
			for i=1 to all_vars.count do
			(
				if (edt_var_name.text==all_vars[i].name) do
				(
					all_vars[i].type = rbt_var_type.state
					all_vars[i].value = (getNewVarValue())
				)
			)
		)
		
		refreshVarsList()
		lbx_vars.selection = lbx_vars.items.count
		refreshVarUI()
	)
	on btn_var_del pressed do
	(
		if (lbx_vars.selection!=0)do(
		if (querybox "Really delete selected variable?" title:maintitle) do
		(
			try(deleteItem all_vars lbx_vars.selection)catch()
			refreshVarsList()
			lbx_vars.selection = lbx_vars.items.count
			refreshVarUI()
			if (lbx_vars.items.count==0) do all_vars=#()
		))
	)
	on btn_reset pressed do
	(
		if (querybox "Really reset?" title:maintitle) do
		(
			all_vars=#()
			all_rules=#()
			deleteAllObjects()
			all_objects=#()
			spn_seed.value=1
			chk_autoupdate.checked=false
			edt_var_name.text=""
			
			refreshVarsList()
			refreshRulesList()
			
			rbt_var_type.state=1
			setVarType()
			
			spn_var_int.value=spn_var_float.value=spn_var_random_min.value=spn_var_random_max.value=0
		)
	)
	on btn_var_up pressed do moveVar "up"
	on btn_var_down pressed do moveVar "down"
	on edt_var_name entered val do updateVar()
	on spn_var_int changed val do updateVar()
	on spn_var_float changed val do updateVar()
	on rbt_var_bool changed val do updateVar()
	on edt_var_expr entered val do updateVar()
	on spn_var_random_min changed val do updateVar()
	on spn_var_random_max changed val do updateVar()
	on rbt_var_const changed val do updateVar()
	on lbx_vars selected sel do
	(
		refreshVarUI()
	)
	on spn_seed changed val do seed spn_seed.value
		
	on btn_rule_add pressed do (disableRulesUI(); filein "quasiCrystals3_addrule.ms")
	on btn_rule_edit pressed do
	(
		if(lbx_rules.selection!=0) do
		(
			disableRulesUI()
			filein "quasiCrystals3_editrule.ms"
		)
	)
	on lbx_rules selected sel do
	(
		btn_rule_on.checked = all_rules[lbx_rules.selection].enabled
	)
	on lbx_rules doubleclicked sel do (
		disableRulesUI()
		filein "quasiCrystals3_editrule.ms"
	)
	on btn_rule_on changed state do
	(
		setRule state
	)
	on btn_rule_up pressed do moveRule "up"
	on btn_rule_down pressed do moveRule "down"
	on btn_rule_del pressed do
	(
		if (lbx_rules.selection!=0)do(
		if (querybox "Really delete selected rule?" title:maintitle) do
		(
			try(deleteItem all_rules lbx_rules.selection)catch()
			refreshRulesList()
			lbx_rules.selection = lbx_rules.items.count
			--refreshVarUI()
			if (lbx_rules.items.count==0) do all_rules=#()
		))
	)
	
	on btn_eval pressed do
	(
		evalCode()
	)
	
	on btn_save_config pressed do
	(
		local cfg_file = getSaveFileName caption:"Save configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
		
		if cfg_file!=undefined do
		(
			slib.csetting.save cfg_file "General" "seed" spn_seed.value
			slib.csetting.save cfg_file "General" "autoupdate" chk_autoupdate.checked
			
			slib.csetting.save cfg_file "General" "vars" (getVarsSave())
			slib.csetting.save cfg_file "General" "rules" (getRulesSave())
		)
	)
	on btn_load_config pressed do
	(
		local cfg_file = getOpenFileName caption:"Load configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
		
		if cfg_file!=undefined do
		(
			spn_seed.value=slib.csetting.load cfg_file "General" "seed" 1
			chk_autoupdate.checked=slib.csetting.load cfg_file "General" "autoupdate" false
			
			all_vars = getVarsLoad (slib.csetting.loadStr cfg_file "General" "vars" "")
			
			refreshVarsList()
			lbx_vars.selection = lbx_vars.items.count
			refreshVarUI()
			
			all_rules = getRulesLoad (slib.csetting.loadStr cfg_file "General" "rules" "")
			refreshRulesList()
			lbx_rules.selection = lbx_rules.items.count
		)
	)
	
	on btn_import_config pressed do
	(/*
		local cfg_file = getOpenFileName caption:"Load configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
		
		if cfg_file!=undefined do
		(*/
			filein "quasiCrystals3_import.ms"
		/*)*/
	)
	
	on quasiCrystals3 open do
	(
		slib.file.init configfile "config"
		loadAllSettings()
		
		btn_rule_on.checked = all_rules[lbx_rules.selection].enabled
		--if(chk_autoupdate.checked) do evalCode()
	)
	
	on quasiCrystals3 close do
	(
		slib.workDlg.open()
		slib.workDlg.job "Working ..."
		
		deleteAllObjects()
		saveAllSettings()
		all_vars=#()
		all_rules=#()
		all_objects=#()
		closeAllDialogs()
		gc()
		clearListener()
		
		slib.workDlg.close()
	)
)