global quasiCrystals3_addrule

rollout quasiCrystals3_addrule "quasiCrystals3 - Add new rule" width:628 height:470
(	
	local configfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiCrystals3\\")+"quasiCrystals3.ini")
	
	local all_rules_names = #("<none>")
	
	local chunks = #("<none>")
	
	local intro_text = "_this -- current object (geometry)\
_i -- current iteration integer\
_it -- total current iterations\
_parent -- parent object (if current rule is nested)\
_p -- current parent iteration\
_pt  -- total parent iteration";
	local intro_text = ""


	/*struct rule_struct
	(
		name=" ",
		enabled=true,
		iterations=" ",
		parent=" ",
		nth=" ",
		obj_type=1,
		obj_inst,
		size=" ",
		preeval=" ",
		eval=" ",
		color_start=(color 160 190 50),
		color_end=(color 160 190 50)
	)*/
	
	
	group "Rule:"
	(
		edittext edt_rule_name "Name:" width:314
		groupbox grp1 "" pos:[15,38] width:123 height:57
		label lbl1 "Iterations (_it):" pos:[20,48]
		edittext edt_iterations "" pos:[17,68] width:116
		--spinner spn_iterations "Iterations:" type:#integer range:[1,spinner_max,1] fieldwidth:50 pos:[20,48]
		
		groupbox grp0 "" pos:[143,38] width:192 height:57 visible:false
		edittext edt_nth "Evaluate this rule every:" pos:[148,48] width:180 visible:false
		label lbl3 "iter. of:" pos:[148,68] visible:false
		dropdownlist ddl_parent "" items:all_rules_names pos:[190,68] width:140 height:(all_rules_names.count + 1) visible:false
		--checkbox chk_use_var "Var:" pos:[20,68] tooltip:"Use variable value instead of fixed value"
		--dropdownlist ddl_use_var "" items:all_vars_names pos:[65,66] width:70 height:(all_vars_names.count + 1) enabled:false
		
		groupbox grp2 "" pos:[343,8] width:1 height:87
		dropdownlist ddl_obj_type "Geometry (_this):" pos:[350,21] width:140 items:obj_types
		label lbl2 "Size:" pos:[500,21] tooltip:"Scale transformations will be applied uniformly"
		edittext edt_obj_size "" pos:[497,41] width:116 tooltip:"Scale transformations will be applied uniformly"
		colorpicker clr_color_start "Wirecolor from:" pos:[350,69] color:(color 160 190 50)
		colorpicker clr_color_end "to:" pos:[478,69] color:(color 160 190 50) visible:false
		checkbox chk_color_random "Random" pos:[552,73] visible:false
		
		label lbl0 "Pre-eval (executed once):                        Evaluation code (executed every iteration '_i' ):" pos:[20,98]
		edittext edt_preeval "" width:196 height:240
		edittext edt_eval "" width:400 height:240 pos:[212,116]
	)
	
	label lbl5 "Insert chunk of code:" pos:[8,370] visible:false
	dropdownlist ddl_chunks "" items:chunks width:288 pos:[120,370] visible:false
	button btn_edit_chunks "Edit chunks ..." width:200 pos:[420,370] visible:false
	
	label lbl4 ""
	button btn_ok "ADD" width:120 height:32 align:#center
	
	checkbox chk_active "enabled" checked:true pos:[44,5]
	
	include "santex_fnlib.ms"
	
	
	fn addNewRule=
	(
		local new_rule = rule_struct()
		new_rule.name = edt_rule_name.text
		new_rule.enabled = chk_active.checked
		new_rule.iterations = edt_iterations.text
		new_rule.parent = " "  -- TODO
		new_rule.nth = edt_nth.text
		new_rule.obj_type = ddl_obj_type.selection
		new_rule.obj_inst = " " -- TODO
		new_rule.size = edt_obj_size.text
		if(edt_preeval.text=="") then new_rule.preeval = " "
		else new_rule.preeval = edt_preeval.text
		if(edt_eval.text=="") then new_rule.eval = " "
		else new_rule.eval = edt_eval.text
		
		new_rule.color_start = clr_color_start.color
		new_rule.color_end = clr_color_end.color
		
		append all_rules new_rule
		
		--print new_rule
	)
	
	
	on btn_cancel pressed do destroydialog quasiCrystals3_addrule
	
	on btn_ok pressed do
	(
		if (edt_rule_name.text!="" AND \
			edt_iterations.text!="") do
		(
			if ((ddl_parent.selection>1 AND edt_nth.text!="")\
			OR (ddl_parent.selection==1)) do
			(
				addNewRule()
				
				destroydialog quasiCrystals3_addrule
				quasiCrystals3.refreshRulesList()
				quasiCrystals3.lbx_rules.selection=quasiCrystals3.lbx_rules.items.count
				return true
			)
		)
		messagebox "Make sure that name and iterations are set !" title:maintitle
	)
	
	on quasiCrystals3_addrule open do
	(
		edt_iterations.text="1"  -- TODO !!! load if defined
		edt_obj_size.text="10"  -- TODO !!! load if defined
		edt_nth.text="1"  -- TODO !!! load if defined
		edt_eval.text=intro_text --TODO !!!!!
		edt_rule_name.text=("rule" + (quasiCrystals3.lbx_rules.items.count + 1) as string)
		
		slib.dlg.setPos quasiCrystals3_addrule (slib.setting.load "addrule.pos" "[0,0]")
	)
	
	on quasiCrystals3_addrule close do
	(
		quasiCrystals3.enableRulesUI()
		
		slib.setting.save "addrule.pos" (getDialogPos quasiCrystals3_addrule)
	)
)
createdialog quasiCrystals3_addrule