rollout quasiSpirals "quasiSpirals - 3D spiral analyzer" width:180 height:370
			(
				local maintitle="quasiSpirals"
				local copyright="(c)2011 by santex"
				local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\quasiSpirals\\")
				local configfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiSpirals\\")+"quasiSpirals.ini")
				local devlogfile=(((getdir #maxroot)+"plugcfg\\santexTools\\quasiSpirals\\")+"quasiSpirals.log")
				local all_objects=#()
				
				spinner spn_iterations "Iterations" pos:[8,8] width:152 fieldWidth:50 range:[0,1597,377] type:#integer tooltip:"Number of iterations (objects created)"
				spinner spn_object_size "Object Size" pos:[8,32] width:152 fieldWidth:50 range:[0,100,5] type:#float tooltip:"Size of objects (initial, if 'Increase Size' is checked; 0 = no objects)"
				spinner spn_object_detail "Object Detail" pos:[8,56] width:152 fieldWidth:50 range:[1,16,3] type:#integer tooltip:"Geosphere (object) subdivisions"
				spinner spn_distribution_angle "Distribution Angle" pos:[8,80] width:152 fieldWidth:50 range:[0,360,222.497] type:#float tooltip:"Angle of distribution between each iteration"
				spinner spn_distance_factor "Distance Factor" pos:[8,104] width:152 fieldWidth:50 range:[0,1,1] type:#float tooltip:"Relative distance multiplier between each iteration"
				checkbox chk_use_instances "Use instances" pos:[8,128] checked:true width:152 tooltip:"If checked, objects are instances (saves memory, also 'Increase Size' is disabled)"
				checkbox chk_increase_size "Increase Size" pos:[8,152] checked:false width:152 tooltip:"Object size will increase each iteration"
				spinner spn_increase_value "Decrease Value" pos:[8,176] width:152 fieldWidth:50 range:[7,100,35] type:#float tooltip:"Reduce size increase (bigger values produce smaller objects)"
				button btn_update "UPDATE" pos:[8,200] width:152 height:21 tooltip:"Update scene" tooltip:"Manulay update scene"
				checkbox chk_autoupdate "Automatic update" width:152 pos:[8,224] checked:true tooltip:"If checked, scene will be updated automatically"
				checkbox chk_autoextents "Automatic viewport extends" width:152 pos:[8,248] checked:true tooltip:"Update viewport, so everything is in view"
				checkbox chk_use_one_color "Use one color" width:152 pos:[8,272] checked:true tooltip:"Use single color for all objects"
				checkbox chk_draw_line "Draw line between points" width:152 pos:[8,296] checked:false tooltip:"If checked, objects will be connected with line"
				spinner spn_everyNth "Connect every Nth" widht:152 pos:[8,320] fieldWidth:50 range:[1,1597,1] type:#integer tooltip:"Select which iteration of points will be connected ('Draw line between points' must be enabled)"
				--button btn_reset "Reset Settings" width:152 pos:[8,340]
				spinner spn_line_thick "Render line thickness:" range:[0,100,0] type:#float
				
				spinner spn_z "z:" range:[0,999,0] type:#float
				spinner spn_addX "Addition to X:" range:[1,999,1] type:#float
				spinner spn_addY "Addition to Y:" range:[1,999,1] type:#float
				spinner spn_addZ "Addition to Z:" range:[0,999,0] type:#float
				checkbox chk_z_log "Logarithmic Z"
				
				button btn_save_settings "Save current configuration" width:210
				button btn_load_settings "Load configuration" width:210
				
				button btn_reset "Reset Settings" width:210
				
				include "santex_fnlib.ms"
				
				
				fn saveAllSettings=
				(
					slib.setting.save "iterations" spn_iterations.value
					slib.setting.save "object_size" spn_object_size.value
					slib.setting.save "object_detail" spn_object_detail.value
					slib.setting.save "distribution_angle" spn_distribution_angle.value
					slib.setting.save "distance_factor" spn_distance_factor.value
					slib.setting.save "use_instances" chk_use_instances.checked
					slib.setting.save "increase_size" chk_increase_size.checked
					slib.setting.save "increase_value" spn_increase_value.value
					slib.setting.save "autoupdate" chk_autoupdate.checked
					slib.setting.save "autoextents" chk_autoextents.checked
					slib.setting.save "use_one_color" chk_use_one_color.checked
					slib.setting.save "draw_line" chk_draw_line.checked
					slib.setting.save "draw_everyNth" spn_everyNth.value
					slib.setting.save "z" spn_z.value
					slib.setting.save "addx" spn_addX.value
					slib.setting.save "addy" spn_addY.value
					slib.setting.save "addz" spn_addZ.value
					slib.setting.save "lineThickness" spn_line_thick.value
					slib.setting.save "z_log" chk_z_log.checked
				)
				fn loadAllSettings=
				(
					spn_iterations.value=slib.setting.load "iterations" 377
					spn_object_size.value=slib.setting.load "object_size" 5
					spn_object_detail.value=slib.setting.load "object_detail" 3
					spn_distribution_angle.value=slib.setting.load "distribution_angle" 222.497
					spn_distance_factor.value=slib.setting.load "distance_factor" 1
					chk_use_instances.checked=slib.setting.load "use_instances" true
					chk_increase_size.checked=slib.setting.load "increase_size" false
					spn_increase_value.value=slib.setting.load "increase_value" 35
					chk_autoupdate.checked=slib.setting.load "autoupdate" true
					chk_autoextents.checked=slib.setting.load "autoextents" true
					chk_use_one_color.checked=slib.setting.load "use_one_color" true
					chk_draw_line.checked=slib.setting.load "draw_line" false
					spn_everyNth.value=slib.setting.load "draw_everyNth" 1
					spn_z.value=slib.setting.load "z" 0
					spn_addX.value=slib.setting.load "addx" 1
					spn_addY.value=slib.setting.load "addy" 1
					spn_addZ.value=slib.setting.load "addz" 0
					spn_line_thick.value=slib.setting.load "lineThickness" 0
					chk_z_log.checked=slib.setting.load "z_log" false
				)
				
				fn saveSettings=
				(
					
					local cfg_file = getSaveFileName caption:"Save configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
					
					if cfg_file!=undefined do
					(
						slib.csetting.save cfg_file "General" "iterations" spn_iterations.value
						slib.csetting.save cfg_file "General" "object_size" spn_object_size.value
						slib.csetting.save cfg_file "General" "object_detail" spn_object_detail.value
						slib.csetting.save cfg_file "General" "distribution_angle" spn_distribution_angle.value
						slib.csetting.save cfg_file "General" "distance_factor" spn_distance_factor.value
						slib.csetting.save cfg_file "General" "use_instances" chk_use_instances.checked
						slib.csetting.save cfg_file "General" "increase_size" chk_increase_size.checked
						slib.csetting.save cfg_file "General" "increase_value" spn_increase_value.value
						slib.csetting.save cfg_file "General" "autoupdate" chk_autoupdate.checked
						slib.csetting.save cfg_file "General" "autoextents" chk_autoextents.checked
						slib.csetting.save cfg_file "General" "use_one_color" chk_use_one_color.checked
						slib.csetting.save cfg_file "General" "draw_line" chk_draw_line.checked
						slib.csetting.save cfg_file "General" "draw_everyNth" spn_everyNth.value
						slib.csetting.save cfg_file "General" "z" spn_z.value
						slib.csetting.save cfg_file "General" "addx" spn_addX.value
						slib.csetting.save cfg_file "General" "addy" spn_addY.value
						slib.csetting.save cfg_file "General" "addz" spn_addZ.value
						slib.csetting.save cfg_file "General" "lineThickness" spn_line_thick.value
						slib.csetting.save cfg_file "General" "z_log" chk_z_log.checked
					)
				
				)
				
				
				
				fn drawLine pointA pointB =
				(
				  ss = SplineShape pos:pointA
				  addNewSpline ss
				  addKnot ss 1 #corner #line PointA
				  addKnot ss 1 #corner #line PointB
				  updateShape ss
				  ss
				)
				fn deleteAllObjects=
				(
					for i=1 to all_objects.count do
					(
						try (delete all_objects[i])catch()
					)
				)
				
				fn update_quasiCrystals=
				(
					deleteAllObjects()
					
					wirecolor=(color 160 190 50)
					main_object=geoSphere radius:quasiSpirals.spn_object_size.value segments:quasiSpirals.spn_object_detail.value wirecolor:wirecolor
					all_objects=#()
					d_angle=quasiSpirals.spn_distribution_angle.value
					prev_pos=[0,0,0]
					draw_line=true
					drawlineCounter=1

					append all_objects main_object
					for i=1 to quasiSpirals.spn_iterations.value do
					(
						local new_object
						local pos=[0,0,0]
						if chk_use_one_color.checked!=true do
						(
							wirecolor=(color (random 0 255) (random 0 255) (random 0 255))
						)
						if d_angle>=360 do
						(
							d_angle=(d_angle-360)
						)						
						pos.x=((cos d_angle)*(i*spn_distance_factor.value)*spn_addX.value)
						pos.y=((sin d_angle)*(i*spn_distance_factor.value)*spn_addY.value)
						
						if (chk_z_log.checked AND spn_addZ.value>0)then pos.z=(i*spn_z.value*(i*spn_addZ.value))
						else pos.z=(i*spn_z.value+(i*spn_addZ.value))
						
						if spn_object_size.value!=0 do
						(
							if quasiSpirals.chk_use_instances.checked then new_object=instance main_object
							else if quasiSpirals.chk_increase_size.checked then
							(
								local new_object_size=(quasiSpirals.spn_object_size.value+(i/quasiSpirals.spn_increase_value.value))
								new_object=geoSphere radius:new_object_size segments:quasiSpirals.spn_object_detail.value
							)
							else new_object=geoSphere radius:quasiSpirals.spn_object_size.value segments:quasiSpirals.spn_object_detail.value
							
							new_object.wirecolor=wirecolor						
							new_object.pos=[pos.x,pos.y,pos.z]						
							append all_objects new_object
						)
						
						if chk_draw_line.checked do
						(
							if (draw_line) then
							(
								new_spline = drawLine prev_pos [pos.x,pos.y,pos.z]
								new_spline.wirecolor=wirecolor
								
								if (spn_line_thick.value>0) then
								(
									new_spline.render_displayRenderMesh = true
									new_spline.render_renderable = true
									new_spline.render_thickness = spn_line_thick.value
									new_spline.render_sides = 6
									new_spline.render_threshold = 90
								)else
								(
									new_spline.render_displayRenderMesh = false
									new_spline.render_renderable = false
								)
								
								append all_objects new_spline
								
								prev_pos=[pos.x,pos.y,pos.z]
								
								draw_line=false
							)
							
							if ((drawlineCounter-1)==(spn_everyNth.value as integer)) then
							(
								drawlineCounter=1
								draw_line=true
							)
							drawlineCounter = drawlineCounter+1
						)
						
						d_angle+=quasiSpirals.spn_distribution_angle.value
					)

					gc()
					
					if chk_autoextents.checked do max zoomext sel all
						
					clearUndoBuffer()
					completeRedraw()
				)
				
				
				
				
				
				on quasiSpirals open do
				(
					
					slib.file.init configfile "config"
					slib.dlg.setPos quasiSpirals (slib.setting.load "dlgpos" [0,0])
					loadAllSettings()
					update_quasiCrystals()
				)
				on quasiSpirals close do
				(
					saveAllSettings()
					deleteAllObjects()
					gc()
				)
				on quasiSpirals moved newpos do
				(
					slib.setting.save "dlgpos" newpos
				)
				
				
				
				
				on spn_iterations changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_object_size changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_object_detail changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_distribution_angle changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_distance_factor changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on chk_use_instances changed state do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on chk_increase_size changed state do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_increase_value changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on chk_autoupdate changed state do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on chk_autoextents changed state do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on chk_use_one_color changed state do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on chk_draw_line changed state do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_everyNth changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				
				on btn_update pressed do
				(
					update_quasiCrystals()
				)
				on btn_reset pressed do
				(
					spn_iterations.value=377
					spn_object_size.value=5
					spn_object_detail.value=3
					spn_distribution_angle.value=222.497
					spn_distance_factor.value=1
					chk_use_instances.checked=true
					chk_increase_size.checked=false
					spn_increase_value.value=35
					chk_autoupdate.checked=true
					chk_autoextents.checked=true
					chk_use_one_color.checked=true
					chk_use_one_color.checked=false
					chk_draw_line.checked=false
					spn_everyNth.value=1
					spn_z.value=0
					spn_addX.value=1
					spn_addY.value=1
					spn_addZ.value=0
					spn_line_thick.value=0
					chk_z_log.checked=false
					
					saveAllSettings()
					
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_z changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_addX changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_addY changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_addZ changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on chk_z_log changed state do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				on spn_line_thick changed val do
				(
					if chk_autoupdate.checked do update_quasiCrystals()
				)
				
				on btn_save_settings pressed do
				(
					saveSettings()
				)
				
				on btn_load_settings pressed do
				(
					
					local cfg_file = getOpenFileName caption:"Load configuration file" types:"Configuration files(*.ini)|*.ini" filename:cfgdir
					
					if cfg_file!=undefined do
					(
						spn_iterations.value=slib.csetting.load cfg_file "General" "iterations" 377
						spn_object_size.value=slib.csetting.load cfg_file "General" "object_size" 5
						spn_object_detail.value=slib.csetting.load cfg_file "General" "object_detail" 3
						spn_distribution_angle.value=slib.csetting.load cfg_file "General" "distribution_angle" 222.497
						spn_distance_factor.value=slib.csetting.load cfg_file "General" "distance_factor" 1
						chk_use_instances.checked=slib.csetting.load cfg_file "General" "use_instances" true
						chk_increase_size.checked=slib.csetting.load cfg_file "General" "increase_size" false
						spn_increase_value.value=slib.csetting.load cfg_file "General" "increase_value" 35
						chk_autoupdate.checked=slib.csetting.load cfg_file "General" "autoupdate" true
						chk_autoextents.checked=slib.csetting.load cfg_file "General" "autoextents" true
						chk_use_one_color.checked=slib.csetting.load cfg_file "General" "use_one_color" true
						chk_draw_line.checked=slib.csetting.load cfg_file "General" "draw_line" false
						spn_everyNth.value=slib.csetting.load cfg_file "General" "draw_everyNth" 1
						spn_z.value=slib.csetting.load cfg_file "General" "z" 0
						spn_addX.value=slib.csetting.load cfg_file "General" "addx" 1
						spn_addY.value=slib.csetting.load cfg_file "General" "addy" 1
						spn_addZ.value=slib.csetting.load cfg_file "General" "addz" 0
						spn_line_thick.value=slib.csetting.load cfg_file "General" "lineThickness" 0
						chk_z_log.checked=slib.csetting.load cfg_file "General" "z_log" false
						
						if chk_autoupdate.checked do update_quasiCrystals()
					)
				
				)

			)