-- v0.1 (developed beta version, based on quasicrystals3 script)

global santexToolbox

struct vars_struct
(
	caption="",
	name="",
	type=1,
	handler=1,
	value="",
	use=true,
	custom_handler=""
)
struct adv_setts_struct
(
	internal=false,
	hide_ctrl=false,
	locked=false
)
struct tool_options_struct
(
	num=10,
	rand_scale=false,
	rand_scale_min=100,
	rand_scale_max=100
)
struct tool_struct
(
	name="",
	id="",
	desc="",
	apply_for=1,
	apply_options=tool_options_struct(),
	vars=#(),
	code="",
	adv_setts=adv_setts_struct(),
	include_tools=#()
)
struct toolset_struct
(
	name="",
	author="",
	desc="",
	created="",
	dir="",
	tools=#()
)
global all_toolsets=#()
rcmenu menu_tools
(
	menuItem mi_eval "Execute"-- checked:false
	separator mi_sep1 ""
	menuItem mi_edit "Edit"-- checked:true
	menuItem mi_new "New"
	menuItem mi_dupl "Duplicate"
	menuItem mi_del "Delete"
	separator mi_sep0 ""
	menuitem mi_set_internal "Internal"
	menuitem mi_set_ctrl "Hide UI controls"
	menuitem mi_set_locked "Locked"
	
	
	on mi_eval picked do
	(
		filein "santexToolbox_eval.ms"
	)
	on mi_edit picked do
	(
		include_tools=#()
		edit_tool = santexToolbox.lbx_tools.selection
		filein "santexToolbox_edit.ms"
	)
	on mi_new picked do
	(
		include_tools=#(); filein "santexToolbox_create.ms"
	)
	on mi_dupl picked do
	(
		santexToolbox.duplicate_sel_tool()
	)
	on mi_del picked do
	(
		if(querybox "Do you really want to delete selected tool?" title:"santexToolbox")do
		(
			local filename = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].id + ".ini" 
			deleteFile (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir  + "\\" + filename)
			deleteItem all_toolsets[santexToolbox.ddl_toolset.selection].tools (santexToolbox.lbx_tools.selection)
			santexToolbox.refresh_tools_list()
			--destroydialog santexToolbox_create
		)
	)
	on mi_set_ctrl picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].adv_setts.hide_ctrl = NOT mi_set_ctrl.checked
		santexToolbox.store_new_tool_file (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection])
	)
	
	on mi_set_internal picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].adv_setts.internal = NOT mi_set_internal.checked
		santexToolbox.refresh_tools_list()
		santexToolbox.store_new_tool_file (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection])
	)
	on mi_set_locked picked do
	(
		all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].adv_setts.locked = NOT mi_set_locked.checked
		santexToolbox.refresh_tools_list()
		santexToolbox.store_new_tool_file (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection])
	)
	
	on menu_tools open do
	(
		if(santexToolbox.lbx_tools.selection!=0)then
		(
			local curr_tool = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection]
			mi_set_ctrl.checked = curr_tool.adv_setts.hide_ctrl
			mi_set_internal.checked = curr_tool.adv_setts.internal
			mi_set_locked.checked = curr_tool.adv_setts.locked
			mi_eval.enabled = mi_edit.enabled = mi_dupl.enabled = mi_dupl.enabled = mi_del.enabled = mi_set_ctrl.enabled = mi_set_internal.enabled = true
		)else
		(
			mi_eval.enabled = mi_edit.enabled = mi_dupl.enabled = mi_dupl.enabled = mi_del.enabled = mi_set_ctrl.enabled = mi_set_internal.enabled = false
		)
	)
	on menu_tools close do
	(
		--santexToolbox.store_new_tool_file (all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection])
	)
)	

rollout santexToolbox "santexToolbox" width:248 height:370
(
	global maintitle="santexToolbox"
	global copyright="(c)2014 by santex"
	global cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	global configfile=(((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")+"santexToolbox.cfg")
	global devlogfile=(((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")+"santexToolbox.log")
	
	local lbx_tools_height=64
	local ddl_toolset_items=#()
	local ddl_toolset_selection=0
	
	--global current_tools=#()
	local edit_tool = undefined
	global santexToolbox_ui_hide_internal = false
	global santexToolbox_ui_show_ctrl = true
	global santexToolbox_ui_show_ctrl_captions = true
	
	global santexToolbox_ui_for_items = #("Selection <array of nodes>",
															"Selection <single node, first>",
															"Selection <single node, random>",
															"(Not implemented) Copies from selection <single node, first>",
															"(Not implemented) Copies from selection <single node, random>",
															"(Not implemented) Instancies from selection <single node, first>",
															"(Not implemented) Instancies from selection <single node, random>",
															"<User specified>") 
															
	global santexToolbox_ui_ddl_type_items = #("Expression",
																	"Integer",
																	"Float",
																	"<Node>",
																	"Boolean")
																	
	global santexToolbox_ui_ddl_handler_items = #("<None>",
																		"Edittext (Expression)",
																		"Spinner (Integer)",
																		"Spinner (Float)",
																		"Pickbutton (<Pick scene node>)",
																		"Checkbox (Boolean)",
																		"<User specified>")
																		
	global santexToolbox_ui_user_specified = santexToolbox_ui_for_items.count
	global santexToolbox_ui_ctrl_edittext_height = 80
	global santexToolbox_ui_chk_opened = false
	global current_vars=#()
	global include_tools=#()
	
	dropdownlist ddl_toolset "" items:ddl_toolset_items tooltip:"Loaded Toolsets"
	button btn_new_set "New set" height:22 width:60 pos:[16,32] tooltip:"Create new toolset"
	button btn_set_details "Details" height:22 width:60 pos:[78,32] tooltip:"Show details about current toolset" enabled:false
	button btn_settings "Settings" height:22 width:60 pos:[140,32] tooltip:"Change santexToolbox settings"
	listbox lbx_tools "Tools:" height:lbx_tools_height width:194 enabled:false
	button btn_create "New" tooltip:"Create new tool" height:22 width:60 enabled:false
	button btn_dupl "Duplicate" tooltip:"Duplicate selected tool" height:22 width:60 enabled:false visible:false
	button btn_eval "Execute" tooltip:"Execute (evaluate) selected tool" height:22 width:60 enabled:false visible:true
	button btn_edit "Edit" tooltip:"Edit selected tool" height:22 width:60 enabled:false
	--label lbl0 "----------------------------------------------" width:194 enabled:false
	--spinner spn_lbx_height "Tools list height:" range:[1,64,lbx_tools_height] width:194 type:#integer fieldwidth:40
	
	include "santex_fnlib.ms"
															
	fn get_toolset_info dir filename=
	(
		local ccfg_filename = (dir+filename)
		local toolset_name = slib.csetting.loadStr ccfg_filename "General" "name" "<None>"
		local toolset_author = slib.csetting.loadStr ccfg_filename "General" "author" "<None>"
		local toolset_desc = slib.csetting.loadStr ccfg_filename "General" "desc" ""
		local toolset_created = slib.csetting.loadStr ccfg_filename "General" "created" ""
		local new_toolset = toolset_struct dir:dir name:toolset_name author:toolset_author desc:toolset_desc created:toolset_created
		return new_toolset
	)
	fn get_all_dirs=
	(
		--local tempdirs=#()
		local dirs=getDirectories (cfgdir+"*")
		--print dirs
		return dirs
	)
	fn refresh_tools_list_ui=
	(
		if(lbx_tools.selection!=0)then
		(
			btn_edit.enabled = true
			btn_dupl.enabled = true
			btn_eval.enabled = true
		)else
		(
			btn_edit.enabled = false
			btn_dupl.enabled = false
			btn_eval.enabled = false
		)
	)
	fn refresh_tools_list=
	(
		local temparr=#()
		if(ddl_toolset.selection>0)then
		(
			if(all_toolsets[ddl_toolset.selection].tools.count >0)do
			(
				for i=1 to all_toolsets[ddl_toolset.selection].tools.count do
				(
					local list_entry = (all_toolsets[ddl_toolset.selection].tools[i].name+" (_tool_"+all_toolsets[ddl_toolset.selection].tools[i].id+")")
					if(all_toolsets[ddl_toolset.selection].tools[i].adv_setts.internal == true)do
					(
						list_entry = (" ! "+all_toolsets[ddl_toolset.selection].tools[i].name+" (_tool_"+all_toolsets[ddl_toolset.selection].tools[i].id+")")
					)
					
					if (all_toolsets[ddl_toolset.selection].tools[i].adv_setts.internal == true AND santexToolbox_ui_hide_internal==true)then
					()else append temparr list_entry
				)
				
			)
			lbx_tools.items=temparr
		)else
		(
			lbx_tools.items=temparr
		)
		refresh_tools_list_ui()
	)
	fn refresh_toolset_list_ui=
	(
		if(ddl_toolset.items.count>0)then
		(
			btn_create.enabled = lbx_tools.enabled = btn_set_details.enabled = true
			ddl_toolset.selection=1
		)else
		(
			btn_create.enabled = lbx_tools.enabled = btn_set_details.enabled = false
		)
	)
	fn getReParsedEval str=
	(
		local parsed = ""
		for i=1 to str.count do
		(
			if (str[i]==";") then parsed += "\n"
			else parsed += str[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn get_all_available_tools=
	(
		local all_tools_available = #()
		--local all_toolsets_copy = deepcopy all_toolsets
		if(all_toolsets.count>0)do
		(
			for i=1 to all_toolsets.count do
			(
				if(all_toolsets[i].tools.count>0)do
				(
					for j=1 to all_toolsets[i].tools.count do
					(
						--if(all_toolsets[i].tools[j].id!=all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].id)do
						--(
						local c_t = copy (all_toolsets[i].tools[j])
						append all_tools_available c_t
						--)
					)
				)
			)
		)
		--print all_tools_available
		return all_tools_available
	)
	-- loads tools data from files
	fn getTools tools_files=
	(
		
		local tools_arr = #()
		for i=1 to tools_files.count do
		(
			local tool_name = slib.csetting.loadStr (tools_files[i]) "General" "name" ""
			local tool_id = slib.csetting.loadStr (tools_files[i]) "General" "id" ""
			local tool_desc = slib.csetting.loadStr (tools_files[i]) "General" "desc" ""
			local tool_apply_for = slib.csetting.load (tools_files[i]) "General" "apply_for" 1
			local tool_code = slib.csetting.loadStr (tools_files[i]) "General" "code" ""
			
			local more_options = tool_options_struct num:(slib.csetting.load (tools_files[i]) "Options" "num" 10)\
																	rand_scale:(slib.csetting.load (tools_files[i]) "Options" "rand_scale" false)\
																	rand_scale_min:(slib.csetting.load (tools_files[i]) "Options" "rand_scale_min" 100.0)\
																	rand_scale_max:(slib.csetting.load (tools_files[i]) "Options" "rand_scale_max" 100.0)
			
			local adv_setts = adv_setts_struct internal:(slib.csetting.load (tools_files[i]) "Settings" "internal" false)\
															hide_ctrl:(slib.csetting.load (tools_files[i]) "Settings" "hide_ctrl" false)\
															locked:(slib.csetting.load (tools_files[i]) "Settings" "locked" false)
			
			local current_include_tools = slib.csetting.loadStr (tools_files[i]) "Include" "tools" ""
			current_include_tools = slib.sarray.getarray current_include_tools "|" 0
			
			
			local current_vars_load = #()
			local loaded_vars = slib.csetting.loadStr (tools_files[i]) "General" "vars" ""
			--print loaded_vars
			loaded_vars = slib.sarray.getarray loaded_vars "|" 0
			
			for i=1 to (loaded_vars.count) do
			(
				local cvar_arr = slib.sarray.getarray loaded_vars[i] "~" 0
				local cvar = vars_struct caption:cvar_arr[1]\
													name:cvar_arr[2]\
													type:(cvar_arr[3] as integer)\
													handler:(cvar_arr[4] as integer)\
													value:(getReParsedEval (cvar_arr[5]))\
													use:(cvar_arr[6] as booleanClass)\
													custom_handler:(getReParsedEval (cvar_arr[7]))
				append current_vars_load cvar
			)
			
			local new_tool=tool_struct name:tool_name\
												id:tool_id\
												desc:tool_desc\
												apply_for:tool_apply_for\
												code:(getReParsedEval tool_code)\
												vars:current_vars_load\
												apply_options:more_options\
												adv_setts:adv_setts\
												include_tools:current_include_tools
			append tools_arr new_tool
		)
		
		return tools_arr
	)
	fn refresh_toolset_list=
	(
		local temp_arr=#()
		all_toolsets=#()
		local current_vars_load=#()
		local all_dirs = get_all_dirs()
		local toolset_tools_files = #()
		try(
			--print all_dirs.count
			for i=1 to all_dirs.count do
			(				
				local filename = filterString all_dirs[i]  "\\"
				filename = filename[filename.count] as string
				dir = filename
				filename = filename + "-toolset.ini"
				--local toolset_info = get_toolset_info all_dirs[i] filename
				local ccfg_filename = (all_dirs[i]+filename)
				if(doesFileExist ccfg_filename)do
				(
					local toolset_name = slib.csetting.loadStr ccfg_filename "General" "name" "<None>"
					local toolset_author = slib.csetting.loadStr ccfg_filename "General" "author" "<None>"
					local toolset_desc = slib.csetting.loadStr ccfg_filename "General" "desc" ""
					toolset_desc=getReParsedEval toolset_desc
					local toolset_created = slib.csetting.loadStr ccfg_filename "General" "created" ""
					
					
					local all_tools_files = getFiles (all_dirs[i] + "*.ini")
						for i=1 to all_tools_files.count do
						(
							if(all_tools_files[i] != ccfg_filename) do append toolset_tools_files all_tools_files[i]
						)
						
					local toolset_tools = #()
					toolset_tools = getTools toolset_tools_files
					
					local new_toolset = toolset_struct dir:dir name:toolset_name author:toolset_author desc:toolset_desc created:toolset_created tools:toolset_tools
					
					append all_toolsets new_toolset
					append temp_arr (new_toolset.name + " (" + new_toolset.author + ")")
						toolset_tools_files=#()
				)
			
				--print new_toolset
			)
			ddl_toolset.items = temp_arr
			
			temp_arr=#()
			refresh_toolset_list_ui()
			ddl_toolset.selection=ddl_toolset_selection
		
			refresh_tools_list()
			
			local all_available_tools = #()
			all_available_tools=get_all_available_tools()
			--print all_toolsets.count
			local all_include_tools = #()
			
			
			if(all_toolsets.count>0)do
			(
				for i=1 to all_toolsets.count do
				(
					if(all_toolsets[i].tools.count>0)do
					(
						for j=1 to all_toolsets[i].tools.count do
						(
							if(all_toolsets[i].tools[j].include_tools.count>0)do
							(
								for k=1 to all_toolsets[i].tools[j].include_tools.count do
								(
									for m=1 to all_available_tools.count do
									(
										if(all_toolsets[i].tools[j].include_tools[k]==all_available_tools[m].id)do
										(
											append all_include_tools (copy all_available_tools[m])
										)
									)
								)
								all_toolsets[i].tools[j].include_tools=deepcopy all_include_tools
								all_include_tools=#()
							)
						)
					)
				)
			)
			
			
		/*
			local all_available_tools = get_all_available_tools()
			for i=1 to toolset_tools_files.count do
			(
				local current_included_tools = #()
				
				local file_included_tools = slib.csetting.loadStr (current_included_tools[i]) "Include" "tools" ""
				file_included_tools = slib.sarray.getarray file_included_tools "|" 0
				for i=1 to file_included_tools.count do
				(
					for j=1 to all_available_tools.count do
					(
						if(file_included_tools[i]==all_available_tools[j].id) do
						(
							--append current_included_tools all_available_tools[j]
						)
					)
				)
			)
			--all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.l].a
		*/	
			
		)catch(
			txt = "It seems like existing config data are corrupted !!!\n\n"
			txt += "You can check config folder via 'Settings -> Open configuration folder' button \n"
			txt += "and/or 'Reset specified settings -> Reset all' under 'Misc' category."
			messagebox txt title:"santexToolbox FATAL ERROR !"
		)
	)
	fn add_new_tool new_tool=
	(
		--append current_tools new_tool
		append all_toolsets[santexToolbox.ddl_toolset.selection].tools new_tool
		refresh_tools_list()
	)
	fn edit_sel_tool new_tool=
	(
		edit_tool = lbx_tools.selection
		deleteItem all_toolsets[ddl_toolset.selection].tools (edit_tool)
		insertItem new_tool all_toolsets[ddl_toolset.selection].tools edit_tool
		refresh_tools_list()
	)
	
	fn ui_resize lbx_tools_height=
	(
		santexToolbox.height=((18*lbx_tools_height)+70+36+24)
		lbx_tools.height=(18*lbx_tools_height)
		btn_create.pos=[80,(lbx_tools.height+34+24+34)]
		btn_dupl.pos=[18,(lbx_tools.height+34+24+34)]
		btn_eval.pos=[18,(lbx_tools.height+34+24+34)]
		btn_edit.pos=[144,(lbx_tools.height+34+24+34)]
		--btn_settings.pos=[16,(lbx_tools.height+34+32+24)]
		--lbl0.pos=[16,(lbx_tools.height+34+28)]
		--spn_lbx_height.pos=[194,(lbx_tools.height+34+28+28)]
	)
	fn get_toolsets arr=
	(
		local return_arr=#()
		
		for i=1 to arr.count do
		(
			local toolset_name=slib.sarray.getstr arr[i] "|" 1
			local toolset_author=slib.sarray.getstr arr[i] "|" 2
			local toolset_desc=slib.sarray.getstr arr[i] "|" 3
			local toolset_dir=slib.sarray.getstr arr[i] "|" 4
			local toolset_created=slib.sarray.getstr arr[i] "|" 5
			
			local toolset_tools = #()
			
			local new_toolset=toolset_struct name:toolset_name author:toolset_author desc:toolset_desc dir:toolset_dir created:toolset_created tools:toolset_tools
			
			append all_toolsets new_toolset
			append return_arr (toolset_name+" ("+toolset_author+")")
		)
		
		return return_arr
	)
	
	fn getParsedEval etext=
	(
		local parsed = ""
		for i=1 to etext.count do
		(
			if (etext[i]=="\n") then parsed += ";"
			else parsed += etext[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getVarsSave=
	(
		local temp = ""
		local current_vars_save = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].vars
		for i=1 to current_vars_save.count do
		(
			local var = (current_vars_save[i].caption + "~" +\
							current_vars_save[i].name + "~" +\
							current_vars_save[i].type as string + "~" +\
							current_vars_save[i].handler as string + "~" +\
							(getParsedEval(current_vars_save[i].value as string)) + "~" +\
							current_vars_save[i].use as string + "~" +\
							(getParsedEval(current_vars_save[i].custom_handler)))
			temp += (var + "|")
		)
		return temp
	)
	fn getIncludedTools=
	(
		local return_arr = ""
		if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools.count>0)do
		(
			local c_include = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].include_tools
			for i=1 to c_include.count do
			(
				return_arr += c_include[i].id+"|"
			)
		)
		return return_arr
	)
	fn store_new_tool_file new_tool=
	(
		local filename = cfgdir + (all_toolsets[santexToolbox.ddl_toolset.selection].dir) +"\\"+new_tool.id+ ".ini"
		slib.file.init filename "Tool"
		
		local tool_eval = (getParsedEval (new_tool.code))
		
		slib.csetting.save filename "General" "name" (new_tool.name)
		slib.csetting.save filename "General" "id" (new_tool.id)
		slib.csetting.save filename "General" "desc" (new_tool.desc)
		slib.csetting.save filename "General" "apply_for" (new_tool.apply_for)
		slib.csetting.save filename "General" "code" (tool_eval)
		slib.csetting.save filename "General" "vars" (getVarsSave())
			
		--saveMoreOptions()
		slib.csetting.save filename "Options" "num" (new_tool.apply_options.num)
		slib.csetting.save filename "Options" "rand_scale" (new_tool.apply_options.rand_scale)
		slib.csetting.save filename "Options" "rand_scale_min" (new_tool.apply_options.rand_scale_min)
		slib.csetting.save filename "Options" "rand_scale_max" (new_tool.apply_options.rand_scale_max)
		
			--slib.csetting.save filename "General" "options" (getOptionsSave new_tool.apply_options)
		slib.csetting.save filename "Settings" "internal" (new_tool.adv_setts.internal)
		slib.csetting.save filename "Settings" "hide_ctrl" (new_tool.adv_setts.hide_ctrl)
			slib.csetting.save filename "Settings" "locked" (new_tool.adv_setts.locked)
			
		slib.csetting.save filename "Include" "tools" (getIncludedTools())
	)
	fn duplicate_sel_tool=
	(
		--if(querybox "Do you want to duplicated (copy) selected tool?" title:"santexToolbox") do
		--(
			local dupl_tool = copy all_toolsets[ddl_toolset.selection].tools[lbx_tools.selection]
			dupl_tool.name = dupl_tool.name+" - copy"
			dupl_tool.id = dupl_tool.id+"_cpy"
			store_new_tool_file dupl_tool
			append all_toolsets[ddl_toolset.selection].tools dupl_tool
			refresh_tools_list()
		
		--)
	)
	
	
	on btn_new_set pressed do
	(
		filein "santexToolbox_new_toolset.ms"
	)
	on lbx_tools selected sel do
	(
		refresh_tools_list_ui()
	)
	on btn_create pressed do ( include_tools=#(); filein "santexToolbox_create.ms" )
	on btn_edit pressed do (
		include_tools=#()
		edit_tool = lbx_tools.selection
		filein "santexToolbox_edit.ms"
		--santexToolbox_create.edt_name.text = current_tools[edit_tool].name
		--santexToolbox_create.edt_name.text = "jouman"
		--print ("edit_tool = "+edit_tool as string)
	)
	on btn_dupl pressed do
	(
		duplicate_sel_tool()
	)
	on btn_eval pressed do
	(
		filein "santexToolbox_eval.ms"
	)
	on btn_settings pressed do ( filein "santexToolbox_settings.ms" )
	on btn_set_details pressed do ( filein "santexToolbox_show_details.ms" )
	
	--on spn_lbx_height entered do
	--(
	--	lbx_tools_height=spn_lbx_height.value
	--	ui_resize()
	--)
	
	on santexToolbox open do
	(
		slib.workDlg.open()
		slib.workDlg.job "Loading tools ..."
		
		all_toolset=#()
		gc()
		--current_vars=#()
		slib.file.init configfile "Config"
		ddl_toolset_selection = slib.setting.load "ddl_toolset" 1
		lbx_tools_height=slib.setting.load "spn_lbx_height" 8
		santexToolbox_ui_hide_internal = slib.setting.load "chk_hide_internal" false
		santexToolbox_ui_show_ctrl = slib.setting.load "chk_show_ctrl" true
		santexToolbox_ui_show_ctrl_captions = slib.setting.load "chk_show_ctrl_captions" false
		santexToolbox_ui_ctrl_edittext_height = slib.setting.load "spn_ctrl_edittext_height" 80
		santexToolbox_ui_chk_opened = slib.setting.load "chk_opened" false
		--all_toolsets = slib.sarray.getarray (slib.setting.loadStr "toolsets" "<None>") "^" 0
		--ddl_toolset.items=get_toolsets (slib.sarray.getarray (slib.setting.loadStr "toolsets" "") "^" 0)
		--spn_lbx_height.value=lbx_tools_height
		--try(
			refresh_toolset_list()
		--	)catch(
		--	txt = "It seems like existing config data are corrupted !!!\n\n"
		----	txt += "You can check config folder via 'Settings -> Open configuration folder' button \n"
		--	txt += "and/or 'Reset specified settings -> Reset all' under 'Misc' category."
		--	messagebox txt title:"santexToolbox FATAL ERROR !"
		--)
		ui_resize lbx_tools_height
		
		--print all_toolsets.count
		
		--refresh_toolset_list()
		setFocus santexToolbox.ddl_toolset
		slib.workDlg.close()
	)
	
	on santexToolbox close do
	(
		--if(ddl_toolset.selection>0)do
			--for i=1 to all_toolsets[ddl_toolset.selection].tools.count do store_new_tool_file all_toolsets[ddl_toolset.selection].tools[i]
		gc()
		try(destroydialog santexToolbox_eval)catch()
--		try(destroydialog santexToolbox_eval_show_code)catch()
		--slib.setting.save "lbx_tools_height" spn_lbx_height.value
		slib.setting.save "ddl_toolset" ddl_toolset.selection
	)
	
	on ddl_toolset selected sel do
	(
		--current_tools = #()
		--current_tools = all_toolsets[ddl_toolset.selection].tools
		refresh_tools_list()
	)
	on lbx_tools doubleclicked sel do
	(
		--local current_tool = all_toolsets[ddl_toolset.selection].tools[sel]
		
		filein "santexToolbox_eval.ms"
	)
	on lbx_tools rightClick do
	(
		--if(santexToolbox.lbx_tools.selection>0)do
			popUpMenu menu_tools
	)
)