global santexToolbox_add_var

rollout santexToolbox_add_var "Edit parameter" width:340 height:280
(
	--	local ddl_items=#("Expression","Integer","Float","<Node>","Boolean")
	local ddl_items=santexToolbox_ui_ddl_type_items
	--local ddl_handler_items=#("<None>","Edittext (Expression)","Spinner (Integer)","Spinner (Float)","Pickbutton (<Pick scene node>)","Checkbox (Boolean)")
	local ddl_handler_items=santexToolbox_ui_ddl_handler_items
	local ui_min_size=[340,280]
	local custom_handler_visible=false
	
	dropdownlist ddl_type "* Type:" items:ddl_items tooltip:"Parameter value type"
	edittext edt_var_caption "Caption:" height:24
	edittext edt_var_name "* ID (name):" height:24
	label lbl_equals " = "
	spinner spn_int "Integer value:" fieldwidth:100 type:#integer range:[-999999,999999,1] visible:false pos:[14,130]
	spinner spn_float "Float value:" fieldwidth:100 type:#float range:[-999999,999999,1] visible:false pos:[14,130]
	edittext edt_var_expr "* Expression:" height:60 visible:true pos:[14,130]
	label lbl_node "< Scene node >\n\nTip: Use 'Pickbutton (<pick node>)' option as UI handler." width:340 height:72 visible:false pos:[14,130]
	checkbox chk_bool "TRUE" pos:[14,130] visible:false checked:true
	edittext edt_custom_handler "Custom UI:" height:120 visible:false enabled:true 
	dropdownlist ddl_handler "UI control:" items:ddl_handler_items tooltip:"Parameter handler (User Interface control)"
	button btn_ok "EDIT" width:120 height:32 pos:[(340-230),160+28]
	button btn_cancel "Cancel" width:80 height:32 pos:[240,160+28]
	checkbutton btn_use "ON" visible:true enabled:true width:80 height:32 checked:true tooltip:"If checked, parameter is enabled, otherwise parameter is ignored"
	
	include "santex_fnlib.ms"
	
	fn resizeUI new_size=
	(
		ui_max_size=[(systemTools.GetScreenWidth() - 10),(systemTools.GetScreenHeight() - 100)]
		if(custom_handler_visible)then ui_min_size=[340,400] else ui_min_size=[340,280]
		dlg_size=slib.dlg.resizelim santexToolbox_add_var new_size ui_min_size ui_max_size
		
		ddl_type.width = dlg_size.x-30
		ddl_handler.width = dlg_size.x-30
		edt_var_caption.width = dlg_size.x-75
		edt_var_name.width = dlg_size.x-95
		edt_var_expr.width = dlg_size.x-100
		
		ddl_handler.pos.y = dlg_size.y-45-28
		--edt_custom_handler.pos.y=ddl_handler.pos.y-32-120
		edt_var_expr.height = dlg_size.y-45-28-100-18-40
		
		btn_cancel.pos.y=dlg_size.y-45
		btn_ok.pos.y=dlg_size.y-45
		btn_cancel.pos.x=dlg_size.x-100
		btn_ok.pos.x=dlg_size.x-100-100-30
		
		btn_use.pos = [16,(dlg_size.y-45)]
		
		if(custom_handler_visible)then
		(
			edt_custom_handler.visible=true
			edt_custom_handler.height=120
			--edt_var_expr.height=edt_var_expr.height-140
			edt_custom_handler.width = dlg_size.x-89
			
			edt_var_expr.height=edt_var_expr.height/2
			edt_custom_handler.height=edt_var_expr.height
			
			edt_custom_handler.pos.y=ddl_handler.pos.y-edt_var_expr.height-22
		)else
		(
			edt_custom_handler.visible=false
		)
	)
	fn refresh_ui sel=
	(
		spn_int.visible=\
		spn_float.visible=\
		lbl_node.visible=\
		chk_bool.visible=\
		edt_var_expr.visible=false
		
		if (sel==2) do spn_int.visible=true
		if (sel==3) do spn_float.visible=true
		if (sel==1) do edt_var_expr.visible=true
		if (sel==4) do lbl_node.visible=true
		if (sel==5) do chk_bool.visible=true
		
		if(chk_bool.checked)then chk_bool.text="TRUE" else chk_bool.text="FALSE"
	)
	fn getReParsedEval str=
	(
		local parsed = ""
		for i=1 to str.count do
		(
			if (str[i]==";") then parsed += "\n"
			else parsed += str[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	fn getParsedEval etext=
	(
		local parsed = ""
		for i=1 to etext.count do
		(
			if (etext[i]=="\n") then parsed += ";"
			else parsed += etext[i]
		)
		
		if(parsed==undefined OR parsed=="") do parsed=" "
		return parsed
	)
	
	on btn_use changed val do
	(
		if(val)then btn_use.text = "ON" else btn_use.text = "OFF"
	)
	
	on btn_cancel pressed do destroydialog santexToolbox_add_var
		
	on ddl_type selected sel do
	(
		refresh_ui sel
		
		if((sel==2 AND ddl_handler.selection==5) OR (sel==2 AND ddl_handler.selection==6))do messagebox "Integer parameter type is incompatible with selected 'UI control' !\nPlease change one of them accordingly." title:"santexToolbox"
		if((sel==3 AND ddl_handler.selection==5) OR (sel==3 AND ddl_handler.selection==6))do messagebox "Float parameter type is incompatible with selected 'UI control' !\nPlease change one of them accordingly." title:"santexToolbox"
		if((sel==4 AND ddl_handler.selection==3) OR (sel==4 AND ddl_handler.selection==4) OR (sel==4 AND ddl_handler.selection==6))do messagebox "The <node> parameter type is incompatible with selected 'UI control' !\nPlease change one of them accordingly." title:"santexToolbox"
		if((sel==5 AND ddl_handler.selection==3) OR (sel==5 AND ddl_handler.selection==4) OR (sel==5 AND ddl_handler.selection==5))do messagebox "Boolean parameter type is incompatible with selected 'UI control' !\nPlease change one of them accordingly." title:"santexToolbox"
	
	)
	on ddl_handler selected sel do
	(
		if((sel==3 AND ddl_type.selection==4) OR (sel==3 AND ddl_type.selection==5))do messagebox "Spinner (Integer) UI control is incompatible with selected parameter 'Type' !\nPlease change one of them accordingly." title:"santexToolbox"
		if((sel==4 AND ddl_type.selection==4) OR (sel==4 AND ddl_type.selection==5))do messagebox "Spinner (Float) UI control is incompatible with selected parameter 'Type' !\nPlease change one of them accordingly." title:"santexToolbox"
		if((sel==5 AND ddl_type.selection==2) OR (sel==5 AND ddl_type.selection==3) OR (sel==5 AND ddl_type.selection==5))do messagebox "Pickbutton UI control is incompatible with selected parameter 'Type' !\nPlease change one of them accordingly." title:"santexToolbox"
		if((sel==6 AND ddl_type.selection==2) OR (sel==6 AND ddl_type.selection==3) OR (sel==6 AND ddl_type.selection==4))do messagebox "Checkbutton (Boolean) UI control is incompatible with selected parameter 'Type' !\nPlease change one of them accordingly." title:"santexToolbox"
		
		if(sel==7)then(
			custom_handler_visible=true
			resizeUI (slib.dlg.getSize santexToolbox_add_var)
		)else
		(
			custom_handler_visible=false
			resizeUI (slib.dlg.getSize santexToolbox_add_var)
		)
	)
	
	on santexToolbox_add_var resized new_size do resizeUI new_size
	
	on btn_ok pressed do
	(
		if(edt_var_name.text!="")then
		(
			if(ddl_type.selection==1 AND edt_var_expr.text=="")then
			(
				messagebox "Enter expression!" title:"Error"
			)else
			(
				if(edt_var_caption.text=="")do edt_var_caption.text="$"
				local var_val=undefined
				if(ddl_type.selection==1) do var_val=edt_var_expr.text
				if(ddl_type.selection==2) do var_val=spn_int.value
				if(ddl_type.selection==3) do var_val=spn_float.value
				if(ddl_type.selection==5) do var_val=chk_bool.checked
				local new_var=vars_struct name:edt_var_name.text\
													type:ddl_type.selection\
													value:var_val\
													handler:ddl_handler.selection\
													caption:edt_var_caption.text\
													use:btn_use.checked\
													custom_handler:edt_custom_handler.text
				destroydialog santexToolbox_add_var
				santexToolbox_create.edit_sel_var new_var
				--print new_var
			)
		)else messagebox "Enter parameter name!" title:"Error"
	)
	on chk_bool changed state do
	(
		if(state)then chk_bool.text="TRUE" else chk_bool.text="FALSE"
	)
	
	on santexToolbox_add_var close do
	(
		slib.setting.save "santexToolbox_add_var.pos" (getDialogPos santexToolbox_add_var)
		slib.setting.save "santexToolbox_add_var.size" (getDialogSize santexToolbox_add_var)
	)
	
	on santexToolbox_add_var open do
	(
		edit_tool = santexToolbox.lbx_tools.selection
		edit_var = santexToolbox_create.lbx_vars.selection
		
		if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].handler==7)do custom_handler_visible=true
		
		slib.dlg.setSize santexToolbox_add_var (slib.setting.load "santexToolbox_add_var.size" (getDialogSize santexToolbox_add_var))
		resizeUI (slib.dlg.getSize santexToolbox_add_var)
		slib.dlg.setPos santexToolbox_add_var (slib.setting.load "santexToolbox_add_var.pos" [0,0])
		
		ddl_type.selection = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].type
		edt_var_caption.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].caption
			if(edt_var_caption.text=="$")do edt_var_caption.text=""
		edt_var_name.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].name
		edt_custom_handler.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].custom_handler
		ddl_handler.selection = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].handler
		--if(all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].use=="1")then all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].use=true else all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].use=false
		btn_use.checked = (all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].use as booleanClass)
			if(btn_use.checked)then btn_use.text = "ON" else btn_use.text = "OFF"
		
		if(ddl_type.selection == 1) do edt_var_expr.text = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].value as string
		if(ddl_type.selection == 2) do spn_int.value = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].value as integer
		if(ddl_type.selection == 3) do spn_float.value = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].value as float
		if(ddl_type.selection == 5) do chk_bool.checked = all_toolsets[santexToolbox.ddl_toolset.selection].tools[edit_tool].vars[edit_var].value as booleanClass			
		
		refresh_ui (ddl_type.selection)
			
		--setFocus santexToolbox_add_var.ddl_type
	)
)
createdialog santexToolbox_add_var style:#(#style_border,#style_titlebar,#style_resizing)